#include <bits/stdc++.h>

using namespace std;

int main()
{
    int t;
    cin>>t;
    while(t--)
    {
        int n,m;
        cin>>n>>m;
        long long jesu[n];
        long long nisu[m];
        cin>>jesu[n]>>nisu[m];
        int nmin=jesu[0], nmin2=jesu[0], imin=0, imin2=0;
        for(int i=0;i<n;i++)
        {
            if(jesu[i]<nmin)
            {
                nmin = jesu[i];
                imin = i;
            }
        }
        for(int i=0;i<n;i++)
        {
            if((jesu[i]<nmin2)&&(i != imin))
            {
                nmin2 = jesu[i];
                imin2 = i;
            }
        }
        int br=0;
        for(int i=0;i<m;i++)
        {
            if((nisu[i]-nmin)%(nmin2-nmin)==0)
                br++;
        }
        if(br>0)
            cout<<0<<"\n";
        else
            cout<<1<<"\n";
    }
    return 0;
}